#include "chip.h"
#include <stdlib.h>

typedef struct {
    int id;
    __IO uint32_t *clk_reg;
    uint32_t clk_msk;
    __IO uint32_t *rst_reg;
    uint32_t rst_msk;
} t_per_regs;


static const t_per_regs f_per_regs[] = {
    /* AHB */
    {CHIP_PER_ID_DMA,       &CHIP_REGS_RCC->AHBENR,    CHIP_REGFLD_RCC_AHBENR_DMA_EN,       NULL,                       0},
    {CHIP_PER_ID_SRAM,      &CHIP_REGS_RCC->AHBENR,    CHIP_REGFLD_RCC_AHBENR_SRAM_EN,      NULL,                       0},
    {CHIP_PER_ID_FLASH,     &CHIP_REGS_RCC->AHBENR,    CHIP_REGFLD_RCC_AHBENR_FLITF_EN,     NULL,                       0},
    {CHIP_PER_ID_HSQRT,     &CHIP_REGS_RCC->AHBENR,    CHIP_REGFLD_RCC_AHBENR_HSQRT_EN,     &CHIP_REGS_RCC->AHBRSTR,    CHIP_REGFLD_RCC_AHBRSTR_HSQRT_RST},
    {CHIP_PER_ID_CRC,       &CHIP_REGS_RCC->AHBENR,    CHIP_REGFLD_RCC_AHBENR_CRC_EN,       NULL,                       0},
    {CHIP_PER_ID_HDIV,      &CHIP_REGS_RCC->AHBENR,    CHIP_REGFLD_RCC_AHBENR_HDIV_EN,      &CHIP_REGS_RCC->AHBRSTR,    CHIP_REGFLD_RCC_AHBRSTR_HDIV_RST},
#if CHIP_DEV_SUPPORT_RNG
    {CHIP_PER_ID_RNG,       &CHIP_REGS_RCC->AHBENR,    CHIP_REGFLD_RCC_AHBENR_RNG_EN,       &CHIP_REGS_RCC->AHBRSTR,    CHIP_REGFLD_RCC_AHBRSTR_RNG_RST},
    {CHIP_PER_ID_RNG_ANA,   &CHIP_REGS_RCC->CFGR2,     CHIP_REGFLD_RCC_CFGR2_RNG_AN_EN,     NULL,                       0},
#endif
#if CHIP_DEV_SUPPORT_SAC
    {CHIP_PER_ID_SAC,       &CHIP_REGS_RCC->AHBENR,    CHIP_REGFLD_RCC_AHBENR_SAC_EN,       &CHIP_REGS_RCC->AHBRSTR,    CHIP_REGFLD_RCC_AHBRSTR_SAC_RST},
#endif
    {CHIP_PER_ID_ADC,       &CHIP_REGS_RCC->AHBENR,    CHIP_REGFLD_RCC_AHBENR_ADC_EN,       &CHIP_REGS_RCC->AHBRSTR,    CHIP_REGFLD_RCC_AHBRSTR_ADC_RST},
    /* APB1 */
    {CHIP_PER_ID_TIM3,      &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_TIM3_EN,     &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_TIM3_RST},
#if CHIP_DEV_SUPPORT_TIM4
    {CHIP_PER_ID_TIM4,      &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_TIM4_EN,     &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_TIM4_RST},
#endif
    {CHIP_PER_ID_LPTIM,     &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_LPTIM_EN,    &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_LPTIM_RST},
    {CHIP_PER_ID_TIM6,      &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_TIM6_EN,     &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_TIM6_RST},
    {CHIP_PER_ID_BEEP1,     &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_BEEP1_EN,    &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_BEEP1_RST},
#if CHIP_DEV_BEEPER_CNT >= 2
    {CHIP_PER_ID_BEEP2,     &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_BEEP2_EN,    &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_BEEP2_RST},
#endif
    {CHIP_PER_ID_COMP,      &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_COMP_EN,      NULL,                       0},
    {CHIP_PER_ID_COMP_FILT, &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_COMPFILT_EN,  NULL,                       0},
#if CHIP_DEV_SUPPORT_TSC
    {CHIP_PER_ID_TSC,       &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_TSC_EN,       NULL,                       0},
#endif
    {CHIP_PER_ID_WWDG,      &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_WWDG_EN,      &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_WWDG_RST},
    {CHIP_PER_ID_USART2,    &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_USART2_EN,    &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_USART2_RST},
    {CHIP_PER_ID_LPUART1,   &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_LPUART1_EN,   &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_LPUART1_RST},
#if CHIP_DEV_LPUART_CNT >= 2
    {CHIP_PER_ID_LPUART2,   &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_LPUART2_EN,   &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_LPUART2_RST},
#endif
#if CHIP_DEV_SUPPORT_UART5
    {CHIP_PER_ID_UART5,     &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_UART5_EN,     &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_UART5_RST},
#endif
    {CHIP_PER_ID_I2C1,      &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_I2C1_EN,      &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_I2C1_RST},
    {CHIP_PER_ID_I2C2,      &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_I2C2_EN,      &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_I2C2_RST},
#if CHIP_DEV_CAN_CNT >= 1
    {CHIP_PER_ID_CAN1,      &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_CAN1_EN,      &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_CAN1_RST},
#endif
    {CHIP_PER_ID_PWR,       &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_PWR_EN,       &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_PWR_RST},
    {CHIP_PER_ID_OPA,       &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_OPA_EN,       NULL,                       0},
    /* APB2 */
    {CHIP_PER_ID_AFIO,      &CHIP_REGS_RCC->APB2ENR,   CHIP_REGFLD_RCC_APB2ENR_AFIO_EN,      &CHIP_REGS_RCC->APB2RSTR,   CHIP_REGFLD_RCC_APB2RSTR_AFIO_RST},
    {CHIP_PER_ID_GPIOA,     &CHIP_REGS_RCC->APB2ENR,   CHIP_REGFLD_RCC_APB2ENR_IOPA_EN,      &CHIP_REGS_RCC->APB2RSTR,   CHIP_REGFLD_RCC_APB2RSTR_IOPA_RST},
    {CHIP_PER_ID_GPIOB,     &CHIP_REGS_RCC->APB2ENR,   CHIP_REGFLD_RCC_APB2ENR_IOPB_EN,      &CHIP_REGS_RCC->APB2RSTR,   CHIP_REGFLD_RCC_APB2RSTR_IOPB_RST},
    {CHIP_PER_ID_GPIOC,     &CHIP_REGS_RCC->APB2ENR,   CHIP_REGFLD_RCC_APB2ENR_IOPC_EN,      &CHIP_REGS_RCC->APB2RSTR,   CHIP_REGFLD_RCC_APB2RSTR_IOPC_RST},
#if CHIP_DEV_SUPPORT_PORTD
    {CHIP_PER_ID_GPIOD,     &CHIP_REGS_RCC->APB2ENR,   CHIP_REGFLD_RCC_APB2ENR_IOPD_EN,      &CHIP_REGS_RCC->APB2RSTR,   CHIP_REGFLD_RCC_APB2RSTR_IOPD_RST},
#endif
    {CHIP_PER_ID_GPIOF,     &CHIP_REGS_RCC->APB2ENR,   CHIP_REGFLD_RCC_APB2ENR_IOPF_EN,      &CHIP_REGS_RCC->APB2RSTR,   CHIP_REGFLD_RCC_APB2RSTR_IOPF_RST},
    {CHIP_PER_ID_SPI1,      &CHIP_REGS_RCC->APB2ENR,   CHIP_REGFLD_RCC_APB2ENR_SPI1_EN,      &CHIP_REGS_RCC->APB2RSTR,   CHIP_REGFLD_RCC_APB2RSTR_SPI1_RST},
    {CHIP_PER_ID_SPI2,      &CHIP_REGS_RCC->APB2ENR,   CHIP_REGFLD_RCC_APB2ENR_SPI2_EN,      &CHIP_REGS_RCC->APB2RSTR,   CHIP_REGFLD_RCC_APB2RSTR_SPI2_RST},
#if CHIP_DEV_SPI_CNT >= 3
    {CHIP_PER_ID_SPI3,      &CHIP_REGS_RCC->APB2ENR,   CHIP_REGFLD_RCC_APB2ENR_SPI3_EN,      &CHIP_REGS_RCC->APB2RSTR,   CHIP_REGFLD_RCC_APB2RSTR_SPI3_RST},
#endif
    {CHIP_PER_ID_TIM1,      &CHIP_REGS_RCC->APB2ENR,   CHIP_REGFLD_RCC_APB2ENR_TIM1_EN,      &CHIP_REGS_RCC->APB2RSTR,   CHIP_REGFLD_RCC_APB2RSTR_TIM1_RST},
    {CHIP_PER_ID_TIM8,      &CHIP_REGS_RCC->APB2ENR,   CHIP_REGFLD_RCC_APB2ENR_TIM8_EN,      &CHIP_REGS_RCC->APB2RSTR,   CHIP_REGFLD_RCC_APB2RSTR_TIM8_RST},
    {CHIP_PER_ID_USART1,    &CHIP_REGS_RCC->APB2ENR,   CHIP_REGFLD_RCC_APB2ENR_USART1_EN,    &CHIP_REGS_RCC->APB2RSTR,   CHIP_REGFLD_RCC_APB2RSTR_USART1_RST},
#if CHIP_DEV_SUPPORT_UART6
    {CHIP_PER_ID_UART6,     &CHIP_REGS_RCC->APB2ENR,   CHIP_REGFLD_RCC_APB2ENR_UART6_EN,     &CHIP_REGS_RCC->APB2RSTR,   CHIP_REGFLD_RCC_APB2RSTR_UART6_RST},
#endif
};

static const t_per_regs *get_per_regs(int id) {
    const t_per_regs *ret = 0;
    for (unsigned i = 0; i < sizeof(f_per_regs)/sizeof(f_per_regs[0]); i++) {
        if (f_per_regs[i].id == id) {
            ret = &f_per_regs[i];
            break;
        }
    }
    return ret;
}

void chip_per_rst(int per_id) {
    const t_per_regs *reg = get_per_regs(per_id);
    if (reg && reg->rst_reg) {
        *reg->rst_reg |= reg->rst_msk;
        chip_dmb();
        *reg->rst_reg &= ~reg->rst_msk;
        chip_dsb();
    }
}

void chip_per_clk_en(int per_id) {
    const t_per_regs *reg = get_per_regs(per_id);
    if (reg && reg->clk_reg) {
        *reg->clk_reg |= reg->clk_msk;
    }
}

void chip_per_clk_dis(int per_id) {
    const t_per_regs *reg = get_per_regs(per_id);
    if (reg && reg->clk_reg) {
        *reg->clk_reg &= ~reg->clk_msk;
    }
}

bool chip_per_clk_is_en(int per_id) {
    const t_per_regs *reg = get_per_regs(per_id);
    return  reg && reg->clk_reg && ((*reg->clk_reg & reg->clk_msk) != 0);
}
